// *************************************************************************
//    Debug.h
// *************************************************************************

#ifndef    _DEBUG_H_
#define    _DEBUG_H_

#include "Assert.h"
#include "CallStk.h"

// *************************************************************************

// __PRETTY_FUNCTION__ is a g++-ism

// ****************************

#ifdef    DEBUG

#define  TELL    do { \
        cerr << "Tell: " __FILE__ ":" << __LINE__  << " " \
             << __FUNCTION__ << endl;  \
  } while(0)

#define  TELL2(X)  do { \
        cerr << "Tell: " __FILE__ ":" << __LINE__  << " " << (X) << " " \
             << __FUNCTION__ << endl;  \
  } while(0)

#else

#define  TELL       do {} while(0)
#define  TELL2(X)   do {} while(0)

#endif

// *************************************************************************

#endif    // _DEBUG_H
