// *************************************************************************
//    ModuleExecInfo.h
// *************************************************************************

#ifndef _ModuleExecInfo_H_
#define _ModuleExecInfo_H_

#include "Table.h"
#include "RMarkArray.h"
#include "QFModuleData.h"

// *************************************************************************

class Cor_StorageRelation;

// *************************************************************************

struct Cor_ModuleExecInfo {
    Cor_Table *table;
    Cor_StorageRelation *magic;
    Cor_RMarkArray *rm_Arr;
    Cor_QFModuleData *md;
    InterpDerivedSolver solver;
/*
// SPF_PSN - Is iter_number used only by psn?
    int    iter_number;         //  This is used by psn to determine the
                                //  iteration number of the stored
                                //  computation. On the first iteration
                                //  of an scc, the non-recursive rules
                                //  will also be added to the recursive
                                //  rules.
*/

    Cor_ModuleExecInfo(Cor_QFModuleData *mod, Cor_Table *tab,
            Cor_StorageRelation *mag, InterpDerivedSolver solve)
    {
        md = mod;
        table = tab;
        magic = mag;
        solver = solve;
        rm_Arr = NULL;
// SPF_PSN - Is iter_number used only by psn?
        /*  iter_number = 1;  */
    }
};

// *************************************************************************

#endif _ModuleExecInfo_H_
