// *************************************************************************
//    ServerSolvers.h
// *************************************************************************

#ifndef _ServerSolvers_H_
#define _ServerSolvers_H_

// *************************************************************************

class Cor_BuiltinRelation;
class Cor_TupleIterator;
class Cor_BindEnv;
class Cor_Tuple;

// *************************************************************************

Cor_BindEnv *Cor_AnswerSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_LoginSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_LogoutSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_WhoSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_WhoamiSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_YieldSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_SetQidSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_CollectionSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_UserSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_KillSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_ListSusSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_ResumeSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_SyncSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);

// *************************************************************************

#endif _ServerSolvers_H_
