
//**************************************************************************
//    WodiConnectArray.h
//
//    The PvmConnectArray Class - A class derived from ConnectArray to
//    handle connections by Wodi.
//
//**************************************************************************

#ifdef DO_WODI

#ifndef _WODICONNECTARRAY_H_
#define _WODICONNECTARRAY_H_

#include "ConnectArray.h"
#include "WodiStream.h"

//**************************************************************************

class Cor_WodiConnectArray : public Cor_ConnectArray {

public:

    // Constructor
    Cor_WodiConnectArray();

    // Destructor
    ~Cor_WodiConnectArray();

    // Make a new connection
    int NewConnection();

    // Delete a connection
    void DeleteConnection(int conn_indx);

    // Establish a connection for Explain
    int ExplainConnection();

    // Get the next connection with data and set it up to run
    int NextConn();
};

//**************************************************************************
    
#endif // _WODICONNECTARRAY_H_

#endif // DO_WODI
