// *************************************************************************
//	Adorn.h
// *************************************************************************

#ifndef _Adorn_H_
#define _Adorn_H_

#include "Literal.h"
#include "BitVector.h"
#include "Rule.h"
#include "Collection.h"

// *************************************************************************

int adorn(Cor_Collection *pre_ad_rules,
        Cor_Collection *ad_rules);

void set_best_allowed_adorn(Cor_Literal *lit);
int is_disallowed_adorn(Cor_CArg& name, Cor_BitVector &adorn);

void preprocess_for_grouping(Cor_Collection *orig_rules,
	Cor_Collection *pre_ad_rules);

Cor_CArg& build_ad_grouped_pred_name(Cor_Literal *head);
int grouped_pred_arity(Cor_Literal *head);

char *init_any_adorn(int num);

void create_grouping_rule_1(Cor_Clause *rule, Cor_CArg& new_pred_name,
	int new_pred_arity, Cor_Collection *pre_ad_rules);
void create_grouping_rule_2(Cor_Clause *rule, Cor_CArg& new_pred_name,
	int new_pred_arity, Cor_Collection *pre_ad_rules);

// *************************************************************************

#endif _Adorn_H_
