// *************************************************************************
//    PrioritizeInfo.h
// *************************************************************************

#error "Don't include relation/PrioritizeInfo.h"
 
#ifndef _PrioritizeInfo_H_
#define _PrioritizeInfo_H_

#include "Relation.h"
#include "Debug.h"

// *************************************************************************

class Cor_PrioritizeInfo {
public:
     int argnum;
     int order;
        // > 0 --> maximum first,
        // < 0 --> minimum first,
        // = 0 --> no ordering.

     Cor_Relation *hidden_relation;        // Hidden part of relation
     Cor_PrioritizeInfo *next;

     Cor_PrioritizeInfo(int _order = 0, int _argnum = 0) {
         order = _order;
         argnum = _argnum;
         hidden_relation = NULL;
     }
};

// *************************************************************************

#endif _PrioritizeInfo_H_
