// *************************************************************************
//    BuiltinSetRelation.C
// *************************************************************************

#include "BuiltinSetRelation.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_BuiltinSetRelation::Cor_BuiltinSetRelation(int a, Cor_CArg *n,
    SetProc set_proc) : Cor_BuiltinRelation(a, n, NULL)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    op = set_proc;
    single_success = 0;  
}

// *************************************************************************
Cor_BindEnv *Cor_BuiltinSetRelation::get_next(Cor_TupleIterator& iterator)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    return(op(iterator));
}

// *************************************************************************
