// *************************************************************************
// Suspension.h
// *************************************************************************
// list of suspendContext
// *************************************************************************

#ifndef    _SUSPENSION_H
#define    _SUSPENSION_H
const int Cor_max_suspensions= 500;

const int Cor_server_page_length = 512;
extern int Cor_convert_ans_2_set(int ans);

class Cor_SuspendContext;


// *************************************************************************
class Cor_suspensionClass {

  Cor_SuspendContext *context[Cor_max_suspensions];
  int avail_id(void);        /* next available id for suspension */
 public:
  int set;//global flag for suspension, set = 1: suspend now,
                /* VALUE BEFORE CALLING EVAL: */
                /* set ==-1, don't suspend */
                /* set == 1 + number of answers to generate */
                /* set == 0, suspend upto a page */
  int byte_count;
  Cor_suspensionClass();
 ~Cor_suspensionClass();
  int resume(int id);
  int kill(int id);        // to kill an suspended id
    // To kill all suspends of a user
  int killall(int conn_id, int user_id);  
  int suspend(Cor_SuspendContext *s);
  int list(int id);        // list someone's suspended query
};

// *************************************************************************

#endif   _SUSPENSION_H
